/* dasdna.c autoXml generated file */

#include "common.h"
#include "xap.h"
#include "dasdna.h"

void *dasdnaStartHandler(struct xap *xp, char *name, char **atts);
/* Called by expat with start tag.  Does most of the parsing work. */

void dasdnaEndHandler(struct xap *xp, char *name);
/* Called by expat with end tag.  Checks all required children are loaded. */


void dasdnaDasdnaSave(struct dasdnaDasdna *obj, int indent, FILE *f)
/* Save dasdnaDasdna to file. */
{
struct dasdnaSequence *dasdnaSequence;
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DASDNA>");
fprintf(f, "\n");
for (dasdnaSequence = obj->dasdnaSequence; dasdnaSequence != NULL; dasdnaSequence = dasdnaSequence->next)
   dasdnaSequenceSave(dasdnaSequence, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</DASDNA>\n");
}

struct dasdnaDasdna *dasdnaDasdnaLoad(char *fileName)
/* Load dasdnaDasdna from file. */
{
struct dasdnaDasdna *obj;
xapParseAny(fileName, "DASDNA", dasdnaStartHandler, dasdnaEndHandler, NULL, &obj);
return obj;
}

void dasdnaSequenceSave(struct dasdnaSequence *obj, int indent, FILE *f)
/* Save dasdnaSequence to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<SEQUENCE");
fprintf(f, " id=\"%s\"", obj->id);
fprintf(f, " start=\"%s\"", obj->start);
fprintf(f, " stop=\"%s\"", obj->stop);
fprintf(f, " version=\"%s\"", obj->version);
fprintf(f, ">");
fprintf(f, "\n");
dasdnaDnaSave(obj->dasdnaDna, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</SEQUENCE>\n");
}

struct dasdnaSequence *dasdnaSequenceLoad(char *fileName)
/* Load dasdnaSequence from file. */
{
struct dasdnaSequence *obj;
xapParseAny(fileName, "SEQUENCE", dasdnaStartHandler, dasdnaEndHandler, NULL, &obj);
return obj;
}

void dasdnaDnaSave(struct dasdnaDna *obj, int indent, FILE *f)
/* Save dasdnaDna to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DNA");
fprintf(f, " length=\"%s\"", obj->length);
fprintf(f, ">");
fprintf(f, "%s", obj->text);
fprintf(f, "</DNA>\n");
}

struct dasdnaDna *dasdnaDnaLoad(char *fileName)
/* Load dasdnaDna from file. */
{
struct dasdnaDna *obj;
xapParseAny(fileName, "DNA", dasdnaStartHandler, dasdnaEndHandler, NULL, &obj);
return obj;
}

void *dasdnaStartHandler(struct xap *xp, char *name, char **atts)
/* Called by expat with start tag.  Does most of the parsing work. */
{
struct xapStack *st = xp->stack+1;
int depth = xp->stackDepth;
int i;

if (sameString(name, "DASDNA"))
    {
    struct dasdnaDasdna *obj;
    AllocVar(obj);
    return obj;
    }
else if (sameString(name, "SEQUENCE"))
    {
    struct dasdnaSequence *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        else if (sameString(name, "start"))
            obj->start = cloneString(val);
        else if (sameString(name, "stop"))
            obj->stop = cloneString(val);
        else if (sameString(name, "version"))
            obj->version = cloneString(val);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    if (obj->start == NULL)
        xapError(xp, "missing start");
    if (obj->stop == NULL)
        xapError(xp, "missing stop");
    if (obj->version == NULL)
        xapError(xp, "missing version");
    if (depth > 1)
        {
        if  (sameString(st->elName, "DASDNA"))
            {
            struct dasdnaDasdna *parent = st->object;
            slAddHead(&parent->dasdnaSequence, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "DNA"))
    {
    struct dasdnaDna *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "length"))
            obj->length = cloneString(val);
        }
    if (obj->length == NULL)
        xapError(xp, "missing length");
    if (depth > 1)
        {
        if  (sameString(st->elName, "SEQUENCE"))
            {
            struct dasdnaSequence *parent = st->object;
            slAddHead(&parent->dasdnaDna, obj);
            }
        }
    return obj;
    }
else
    {
    xapSkip(xp);
    return NULL;
    }
}

void dasdnaEndHandler(struct xap *xp, char *name)
/* Called by expat with end tag.  Checks all required children are loaded. */
{
struct xapStack *stack = xp->stack;
if (sameString(name, "DASDNA"))
    {
    struct dasdnaDasdna *obj = stack->object;
    if (obj->dasdnaSequence == NULL)
        xapError(xp, "Missing SEQUENCE");
    slReverse(&obj->dasdnaSequence);
    }
else if (sameString(name, "SEQUENCE"))
    {
    struct dasdnaSequence *obj = stack->object;
    if (obj->dasdnaDna == NULL)
        xapError(xp, "Missing DNA");
    if (obj->dasdnaDna->next != NULL)
        xapError(xp, "Multiple DNA");
    }
else if (sameString(name, "DNA"))
    {
    struct dasdnaDna *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
}

